package com.sgbarlow.sourcecontrol;

import java.util.*;
import org.gjt.sp.util.Log;


class SOSProject
{

    private String m_projName = null;
    private String m_workingFolder = null;


    public SOSProject(String name, String workingFolder)
        throws Exception
    {

        if (!name.startsWith("$/"))
        {
            throw new Exception(
                "SOSProject - project name must begin with '$/'");
        }

        if (name.indexOf("\\") != -1)
        {
            throw new Exception(
                "SOSProject - project name must NOT contain '\'");
        }

        m_projName = name;
        m_workingFolder = workingFolder;
    }


    public void setWorkingFolder(String workingFolder)
    {
        m_workingFolder = workingFolder;
    }


    public void setProjName(String projName)
    {
        m_projName = projName;
    }


    public String getProjName()
    {
        return m_projName;
    }


    public String getWorkingFolder()
    {
        return m_workingFolder;
    }


    public static List factory(Properties props)
        throws Exception
    {
        List retVal = new ArrayList();
        Log.log(Log.DEBUG, SOSProject.class, "starting creating projects");

        Enumeration propertyNames = props.propertyNames();
        for (int i = 0; propertyNames.hasMoreElements(); i++)
        {
            String projname = (String) propertyNames.nextElement();
            String workingFolder = props.getProperty(projname);

            Log.log(Log.DEBUG, SOSProject.class, "creating project: " 
                + projname + " wd: " + workingFolder);

            if ((projname != null) && (!projname.equals("")))
            {
                SOSProject proj = new SOSProject(projname, workingFolder);
                retVal.add(proj);
            }
        }
        return retVal;
    }


    public static Properties toProperties()
    {
        return new Properties();
    }


    public String toString()
    {
        return "SOS Project - name: " + m_projName + " working folder: " + m_workingFolder;
    }
}

