package com.sgbarlow.sourcecontrol;

import org.gjt.sp.jedit.jEdit;
import org.gjt.sp.util.Log;


/**
 *
 */
public class SourceControlInterfaceFactory {

    /**
    * Use this method to get the required source control implementation.
    *
    */
    public static SourceControlInterface getSourceControl() throws ClassNotFoundException, Exception {
        SourceControlInterface retVal = null;
        Log.log(Log.DEBUG, SourceControlInterfaceFactory.class, "getSourceControl");
        String sctype = jEdit.getProperty(SourceControlPlugin.OPTION_PREFIX + "sctype");
        Class scTypeImpl = mapTypeToClass(sctype);
        retVal = (SourceControlInterface)scTypeImpl.newInstance();
        retVal.init();
        return retVal;
    }

    /**
    * Use this method to get the required source control implementation.
    *
    */
    public static SourceControlInterface getSourceControl(String sctype) throws ClassNotFoundException, Exception {
        SourceControlInterface retVal = null;
        Log.log(Log.DEBUG, SourceControlInterfaceFactory.class, "getSourceControl: " + sctype);
        Class scTypeImpl = mapTypeToClass(sctype);
        retVal = (SourceControlInterface)scTypeImpl.newInstance();
        retVal.init();
        return retVal;
    }
    
    private static Class mapTypeToClass(String type) throws ClassNotFoundException {
        Class cluss = null;
        String noSpaces = removeChar(type, ' ');
        cluss = Class.forName("com.sgbarlow.sourcecontrol." + noSpaces + "Impl"); 
        return cluss;
    }
    
    private static String removeChar(String strOrig, char chRemove) {
        if (strOrig == null) return(null);
        
        int strOrigLen = strOrig.length();
        char[] tempArray = new char[strOrigLen];
        
        int j = 0;
        int i = 0;
        char currChar;
        for (i = 0; i < strOrigLen; i++) {
            currChar = strOrig.charAt(i);
            if (currChar != chRemove) {
                tempArray[j] = currChar;
                j++;
            }
        }
        
        // There was nothing to replace, might as well return the
        // original string.
        if (i == j) return(strOrig);
        
        // Create a new string from the array.
        return(new String(tempArray, 0, j));
    }
}
