package com.sgbarlow.sourcecontrol;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JTextField;

import org.gjt.sp.jedit.AbstractOptionPane;
import org.gjt.sp.jedit.GUIUtilities;
import org.gjt.sp.jedit.jEdit;
import org.gjt.sp.util.Log;


/**
 *
 */
public class SourceControlOptionPane extends AbstractOptionPane implements ActionListener {

    //final static String PROPERTY = "VSSIntegration.property.";
	final static String NAME = ".name";
	final static String VALUE = ".value";
    
    private JComboBox m_scType;
    private JCheckBox m_promtBeforeCO;
    private JTextField m_checkoutComment;
    
    /**
    */
    public SourceControlOptionPane() {
        super("General");
    }

    public void _init() {
        // source control type
        m_scType = new JComboBox();
        String sctypes = jEdit.getProperty(SourceControlPlugin.OPTION_PREFIX + "sctypes");
        
        int start = 0;
        int end = 0;
        String type = null;
        while ( (end = sctypes.indexOf(',', start)) != -1 ) {
            type = sctypes.substring(start, end);
            m_scType.addItem(type);
            start = end + 1;
        }
        
        type = sctypes.substring(start, sctypes.length());
        m_scType.addItem(type);
        m_scType.addActionListener(this);
        
        addComponent( jEdit.getProperty(
			SourceControlPlugin.OPTION_PREFIX + "sctypelabel"),
            m_scType );
        
        m_scType.setSelectedItem(jEdit.getProperty(
			SourceControlPlugin.OPTION_PREFIX + "sctype"));
        
        // prompt
        m_promtBeforeCO =  new JCheckBox("", new Boolean(jEdit.getProperty(
			SourceControlPlugin.OPTION_PREFIX + "promptbeforecheckout")).booleanValue() );
        addComponent( jEdit.getProperty(
			SourceControlPlugin.OPTION_PREFIX + "promptbeforecheckoutlabel"),
            m_promtBeforeCO );

        // comment
        m_checkoutComment = new JTextField(jEdit.getProperty(
			SourceControlPlugin.OPTION_PREFIX + "checkoutcomment"));
        addComponent( jEdit.getProperty(
            SourceControlPlugin.OPTION_PREFIX + "checkoutcommentlabel"),
            m_checkoutComment );
    }

    public void actionPerformed(ActionEvent evt) {
        Log.log(Log.DEBUG, SourceControlOptionPane.class, evt.getActionCommand());
        Log.log(Log.DEBUG, SourceControlOptionPane.class, evt.toString());
        Log.log(Log.DEBUG, SourceControlOptionPane.class, evt.getSource().toString());
        
        if ( evt.getActionCommand().indexOf("comboBoxChanged") != -1 ) {
            String scType = (String)m_scType.getSelectedItem();
            
            try {
                SourceControlInterface intf = SourceControlInterfaceFactory.getSourceControl(scType);
            }
            catch (ClassNotFoundException ex) {
                String[] args1 = { ex.getMessage() };
                GUIUtilities.message(null,"sourcecontrol.sctypeclass.error", args1);
            }
            catch (Exception ex) {
                String[] args1 = { ex.getMessage() };
                GUIUtilities.message(null,"sourcecontrol.sctype.error", args1);
            }
            
        } else {
            // some other event
        }
	}
    
    public void _save() {
        jEdit.setProperty(SourceControlPlugin.OPTION_PREFIX + "sctype",
			(String)m_scType.getSelectedItem());
        
        jEdit.setProperty(SourceControlPlugin.OPTION_PREFIX + "promptbeforecheckout",
			new Boolean(m_promtBeforeCO.isSelected()).toString());

        jEdit.setProperty(SourceControlPlugin.OPTION_PREFIX + "checkoutcomment",
			m_checkoutComment.getText());
    }
}

